/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __lua_LuaI_h__
#define __lua_LuaI_h__

namespace fe
{

/// lua execution interface
class FE_DL_EXPORT LuaI : virtual public Component
{
	public:
virtual	bool	preloadString(const String &text)							= 0;
virtual	bool	loadFile(const String &filename)							= 0;
virtual	bool	loadString(const String &text)								= 0;
virtual	void	set(const String &key, Record r_value)						= 0;
virtual	void	set(const String &key, sp<RecordArray> ra_value)			= 0;
virtual	void	set(const String &key, const String &value)					= 0;
virtual	void	set(const String &key, const Real &value)					= 0;
virtual	void	set(const String &key, Vector3 &value)						= 0;
virtual	void	set(const String &key, sp<Layout> l_value)					= 0;
virtual	void	set(const String &key, sp<Component> spValue)				= 0;
virtual	void	set(const String &key, sp<Scope> spValue)					= 0;
virtual	bool	execute(void)												= 0;
virtual	bool	execute(const String &a_fnName)								= 0;
virtual	void	flush(void)													= 0;
virtual	void	alias(String a_aliasName,String a_trueName)					= 0;

};

} /* namespace */

#endif /* __lua_LuaI_h__ */

