/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __network_Client_h__
#define __network_Client_h__

namespace fe
{

class FE_DL_EXPORT ClientI : virtual public Component
{
	public:
virtual	void	setScope(sp<Scope> spScope)								= 0;
virtual	void	addLayout(sp<Layout> spLayout)								= 0;
virtual	void	start(sp<SignalerI> spSignalerI,
					String a_host,
					unsigned short a_port,
					sp<Layout> spPollLayout)								= 0;
virtual	void	stop(void)													= 0;
};

class BSDClient : public ClientI
{
	public:
		BSDClient(void);
virtual	~BSDClient(void);

virtual	void	setScope(sp<Scope> spScope);
virtual	void	addLayout(sp<Layout> spLayout);
virtual	void	start(sp<SignalerI> spSignalerI,
						String a_host,
						unsigned short a_port,
						sp<Layout> spPollLayout);
virtual	void	stop(void);

	private:
		sp<SignalerI>				m_spSignalerI;
		sp<Scope>					m_spScope;
		sp<HandlerI>				m_spSignalSender;
		sp<HandlerI>				m_spSignalReceiver;
		SockAddr					m_serverAddr;
		std::list<sp<Layout> >		m_layouts;
		bool						m_operating;
		sp<Layout>					m_spPollLayout;
		sp<ChunkReceiver>			m_spChunkReceiver;
		sp<ChunkSender>				m_spChunkSender;


};

} /* namespace */

#endif /* __network_Client_h__ */

